/*
 * Makarov Alex
 * alexd.makarov@gmail.com
 * DSI
 */

package ru.dsi.bgbilling.robokassa.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
//   MD5   
import ru.dsi.bgbilling.robokassa.util.md5;
//  
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.BalanceUtils;
//
import bitel.billing.server.contract.bean.Payment;
import bitel.billing.server.contract.bean.PaymentManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.script.bean.event.PaymentEvent;
import bitel.billing.common.BGException;

import java.math.BigDecimal;
//       
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Driver;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.PreparedStatement;
//   mail
import javax.mail.NoSuchProviderException;
import javax.mail.MessagingException;
import ru.dsi.bgbilling.robokassa.util.Mailme;
import java.util.Calendar;
import java.util.GregorianCalendar;
/**
 *
 * @author makarovad
 */

public class roboxre extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    private static Properties props = new Properties();
    //private static String propFile = "c://BGBillingServer//data/data.properties"; // 
    //private static String robopropFile = "d://robokassa.properties"; // 
    //private static String jdbc_url = "jdbc:mysql://localhost/bgbilling"; // 
    private Connection con = null;
    private Mailme mail2me = new Mailme();
    protected static String robopropFile = "/usr/local/BGBillingServer/data/robokassa.properties"; //    BGBilling
    //protected static String robopropFile = "c://BGBillingServer//data//robokassa.properties"; //    BGBilling
    protected static String propFile = "/usr/local/BGBillingServer/data/data.properties"; //    BGBilling
    //protected static String propFile = "c://BGBillingServer//data//data.properties"; //    BGBilling

    private static String jdbc_url = "jdbc:mysql://127.0.0.1/bgbilling"; //    BGBilling
    /*        , 
     *  true  false
    */
    protected synchronized boolean DoConnection(String url){
        //     

        try{
            File propsFile = new File(propFile);
            FileInputStream fis = new FileInputStream(propsFile);
            props.load(fis);
            fis.close();
            String db_user = props.getProperty("db.user");
            String password = props.getProperty("db.pswd");
            String properties_jdbc_url = props.getProperty("db.url");
            DriverManager.registerDriver((Driver)Class.forName("com.mysql.jdbc.Driver").newInstance());
            con = DriverManager.getConnection(properties_jdbc_url,db_user,password);
            return true;
        }catch(Exception e){
            return false;
        }
    }
    protected synchronized void closeConnection(){
        try{
            con.close();
        }catch(SQLException e){
        }
    }

    protected int getIdTypePayment(){
        //  ,     robokassa.properties
        int id_payment = 0;
        try{
            File propsFile = new File(robopropFile);
            FileInputStream fis = new FileInputStream(propsFile);
            props.load(fis);
            fis.close();
            id_payment = Integer.parseInt(props.getProperty("id_payment_robo"));
        }catch(Exception e){
            e.printStackTrace();
            id_payment = -1;
            try{
                mail2me.sendMail("Error in getIdTypePayment value of property id_payment_robo="+props.getProperty("id_payment_robo")+"\n"+e.getMessage(),
                            "IDTYPEPAYMENT");
            }catch(NoSuchProviderException e1){

            }catch(MessagingException e2){

            }
        }
        return id_payment;
    }

    protected synchronized boolean isOkCID(String cid){
        ContractManager cm = new ContractManager(con);
        Contract cont =  cm.getContractByID(Integer.parseInt(cid));
        if(cont!=null){
            return true;
        }else{
            return false;
        }
    }

    /**
     *      dsi_payment_robokassa  inv_id  ,   true  false
     * @param invid -  
     * @return true  false
     */
    protected synchronized boolean getRecordPayment(int invid){
        boolean res = false;
        try{
            // pid is null     -   !
            String _sql = "select 1 from dsi_payment_robokassa where inv_id=? and pid is null";
            PreparedStatement ps = con.prepareStatement(_sql);
            ps.setInt(1, invid);
            ResultSet rs = ps.executeQuery();
            if(rs.next()) res = true;
        }catch(SQLException e){
            e.printStackTrace();
            try{
                mail2me.sendMail("SQLError return record in dsi_payment_robokassa InvID="+invid+" \n"+e.getMessage(),"ROBOKASSA_REGISTERPAYMENT");
            }catch(NoSuchProviderException e1){
                e1.printStackTrace();
            }catch(MessagingException e2){
                e2.printStackTrace();
            }
            res = false;
        }
        return res;
    }

    /**
     *
     *   dsi_payment_robokassa     .
     *          InvID
     *..             .
     *       InvID    
     *     .
     * deprecated
     */
    @Deprecated
    protected synchronized boolean registerNewPayment(String chid,String cid,String _sum){
        boolean res = false;
        int iCHID; int iCID;
        BigDecimal dSUM;
        java.util.Date ld = new java.util.Date();
        java.sql.Date sd = new java.sql.Date(ld.getTime());
        try{
            iCHID = Integer.parseInt(chid);
            iCID = Integer.parseInt(cid);
            dSUM = BigDecimal.valueOf(Double.parseDouble(_sum));
        }catch(NumberFormatException e){
            e.printStackTrace();
            return false;
        }
        try{
            String _sql = "insert into dsi_payment_robokassa(inv_id,cid,dt,sum) values(?,?,?,?)";
            PreparedStatement ps = con.prepareStatement(_sql);
            ps.setInt(1, iCHID);
            ps.setInt(2, iCID);
            ps.setDate(3, sd);
            ps.setBigDecimal(4,dSUM);
            ps.executeUpdate();
            res = true;
        }catch(SQLException e){
            e.printStackTrace();
            try{
                mail2me.sendMail("Error while register record in dsi_payment_robokassa CID="+cid+" InvID="+chid+" \n"+e.getMessage(),"ROBOKASSA_REGISTERPAYMENT");
            }catch(NoSuchProviderException e1){
                e1.printStackTrace();
            }catch(MessagingException e2){
                e2.printStackTrace();
            }
            return false;
        }
        return res;
    }

    /**
     *    dsi_payment_robokassa.    ,
     *      , 
     * @param invid -  
     * @param pid -      
     * @param sump -  
     * @return true -    . false -     
     */
    protected synchronized boolean updateRecordPayment(int invid,int pid, BigDecimal sump){
        //   dsi_payment_robokassa     pid= 
        boolean res = false;
        try{
            String _sql = "update dsi_payment_robokassa set pid=?,dtfp=?,sum=?,dtfp_msk=? where inv_id=?";
            java.util.Date ld = new java.util.Date();
            java.sql.Date sd = new java.sql.Date(ld.getTime());
            PreparedStatement ps = con.prepareStatement(_sql);
            ps.setInt(1, pid);
            ps.setDate(2, sd);
            ps.setBigDecimal(3, sump);
            //     
            Calendar g = new GregorianCalendar();
            g.add(GregorianCalendar.HOUR, -5);
            java.sql.Timestamp d = new java.sql.Timestamp(g.getTimeInMillis());
            ps.setTimestamp(4, d);
            ps.setInt(5, invid);
            System.out.println(invid+" pid= "+pid+" sum= "+sump);
            if(ps.executeUpdate() > 0){
                System.out.println("UPDATED");
                res = true;
            }
        }catch(SQLException e){
            e.printStackTrace();
            try{
                mail2me.sendMail("Error while update record in dsi_payment_robokassa PayID="+pid+" \n"+e.getMessage(),"ROBOKASSA_REGISTERPAYMENT");
            }catch(NoSuchProviderException e1){
                e1.printStackTrace();
            }catch(MessagingException e2){
                e2.printStackTrace();
            }
            return false;
        }
        return res;
    }

    @Deprecated
    protected synchronized boolean updateNewPayment(String chid,int pid){
        //   dsi_payment_robokassa     pid= 
        boolean res = false;
        int iCHID;
        try{
            iCHID = Integer.parseInt(chid);
        }catch(NumberFormatException e){
            return false;
        }
        try{
            String _sql = "update dsi_payment_robokassa set pid=? where inv_id=?";
            PreparedStatement ps = con.prepareStatement(_sql);
            ps.setInt(1, pid);
            ps.setInt(2, iCHID);
            if(ps.executeUpdate() > 0){
                res = true;
            }
        }catch(SQLException e){
            e.printStackTrace();
            try{
                mail2me.sendMail("Error while update record in dsi_payment_robokassa PayID="+pid+" \n"+e.getMessage(),"ROBOKASSA_REGISTERPAYMENT");
            }catch(NoSuchProviderException e1){
                e1.printStackTrace();
            }catch(MessagingException e2){
                e2.printStackTrace();
            }
            return false;
        }
        return res;
    }

    protected synchronized void processRequest(HttpServletRequest request, HttpServletResponse response)
                                                       throws ServletException, IOException {
        /*    */
        String chid = ""; // 
        String sum_in = ""; // 
        String sMD5 = ""; //  MD5
        String cid = ""; // 
        String clientIP = request.getRemoteAddr();
        String clienthostname = request.getRemoteHost();

        if(request.getParameter("SignatureValue")!=null && request.getParameter("SignatureValue").length()>0){
            //  MD5
            sMD5 = request.getParameter("SignatureValue");
        }
        if(request.getParameter("InvId")!=null && request.getParameter("InvId").length()>0){
            //  MD5
            chid = request.getParameter("InvId");
        }
        if(request.getParameter("OutSum")!=null && request.getParameter("OutSum").length()>0){
            //  MD5
            sum_in = request.getParameter("OutSum");
        }
        if(request.getParameter("shp_contract")!=null && request.getParameter("shp_contract").length()>0){
            //  MD5
            cid = request.getParameter("shp_contract");
        }
        /*      MD5   
           MD5,        
         */

        //  
        if(DoConnection(jdbc_url)){
            //  MD5
            String lMD5 = md5.md5d(sum_in, chid, cid);
            // MD5       
            if(sMD5.equalsIgnoreCase(lMD5)){
                //        
                //isOkCID(cid);
                ///if(contr.)  -  ??????7

                // 
                try{
                    //,       
                    if(getRecordPayment(Integer.parseInt(chid))){
                    //           
                    //if(registerNewPayment(chid, cid, sum_in)){
                        PaymentManager pm = new PaymentManager(con);
                        int idtp = getIdTypePayment();
                        if(idtp == -1){
                            response.setContentType("text/html");
                            PrintWriter out = response.getWriter();
                            out.print("bad sign\n");
                            out.close();
                        }else{
                            Payment pay = new Payment();
                            pay.setContractID(Integer.parseInt(cid));
                            pay.setPaymentTypeID(idtp);
                            Date d = new Date();
                            pay.setDate(d);
                            pay.setComment("   ROBOKASSA.    ROBOKASSA="+chid);
                            pay.setSumma(BigDecimal.valueOf(Double.parseDouble(sum_in)));
                            pm.updatePayment(pay);

                            //       
                            if(!updateRecordPayment(Integer.parseInt(chid), pay.getID(), BigDecimal.valueOf(Double.parseDouble(sum_in)))){
                                //  bad sign
                                System.err.println("ROBOKASSA Error while finish update dsi_paymnet_robokassa payment CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname);
                                response.setContentType("text/html");
                                PrintWriter out = response.getWriter();
                                out.print("bad sign\n");
                                out.close();

                                try{
                                    mail2me.sendMail("ROBOKASSA Error while finish update dsi_paymnet_robokassa payment CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname,
                                    "ERRORPAYMENT_ROBOKASSA");
                                }catch(NoSuchProviderException e1){
                                    e1.printStackTrace();
                                }catch(MessagingException e2){
                                    e2.printStackTrace();
                                }
                            }else{
                                //updateNewPayment(chid,pay.getID());
                                //   .     .
                                BalanceUtils bu = new BalanceUtils(con);
                                bu.updateBalance(d, pay.getContractID());
                                //   
                                EventProcessor.getProcessor().processEvent(new PaymentEvent(-1, pay));
                                // 
                                response.setContentType("text/html");
                                PrintWriter out = response.getWriter();
                                out.print("OK"+chid+"\n");
                                out.close();
                            }
                        }
                    }else{
                    //  bad sign
                        System.out.println("ROBOKASSA Error in MD5 CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname);
                        response.setContentType("text/html");
                        PrintWriter out = response.getWriter();
                        out.print("bad sign\n");
                        out.close();
                        try{
                            mail2me.sendMail("ROBOKASSA Error while finish update dsi_paymnet_robokassa payment CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname,
                                             "ERRORPAYMENT_ROBOKASSA");
                        }catch(NoSuchProviderException e1){
                            e1.printStackTrace();
                        }catch(MessagingException e2){
                            e2.printStackTrace();
                        }
                    }
                }catch(Exception e){
                    e.printStackTrace();
                    System.out.println("ROBOKASSA Error while register payment CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname);
                    response.setContentType("text/html");
                    PrintWriter out = response.getWriter();
                    out.print("Error while register payment\n");
                    out.close();
                    closeConnection();
                    try{
                        mail2me.sendMail("ROBOKASSA Error while register payment CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname,
                            "ERRORPAYMENT_ROBOKASSA");
                    }catch(NoSuchProviderException e1){
                        e1.printStackTrace();
                    }catch(MessagingException e2){
                        e2.printStackTrace();
                    }
                }
            }else{
                response.setContentType("text/html");
                PrintWriter out = response.getWriter();
                out.print("bad sign\n");
                out.close();
                System.out.println("Error in MD5 signature bad_sign="+lMD5+" cid="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname);
                try{
                    mail2me.sendMail("Error in MD5 signature bad_sign="+lMD5+"\n"+"CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname,
                            "BADSIGN_ROBOKASSA");
                }catch(NoSuchProviderException e1){
                    e1.printStackTrace();
                }catch(MessagingException e2){
                    e2.printStackTrace();
                }
            }
            closeConnection();
        }else{
            System.out.println("ROBOKASSA Error DB Connection CID="+cid+" SUMM="+sum_in);
            response.setContentType("text/html");
            PrintWriter out = response.getWriter();
            out.print("Error DB Connection\n");
            out.close();
            try{
                mail2me.sendMail("ROBOKASSA Error DB Connection CID="+cid+" SUMM="+sum_in+" Remote IP="+clientIP+" Remote host="+clienthostname,
                                    "ERRORDBCONNECTION_ROBOKASSA");
            }catch(NoSuchProviderException e1){
                e1.printStackTrace();
            }catch(MessagingException e2){
                e2.printStackTrace();
            }
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}

